package com.example.repeater;

import android.content.Context;
import android.text.Editable;
import android.text.TextWatcher;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

import java.util.ArrayList;

public class ListViewAdapter extends BaseAdapter {
    // Adapter에 추가된 데이터를 저장하기 위한 ArrayList
    private ArrayList<ListViewItem> listViewItemList = new ArrayList<ListViewItem>() ;
    private ArrayList<ListViewItem> filteredItemList = listViewItemList;

    // ListViewAdapter의 생성자
    public ListViewAdapter() {

    }

    // Adapter에 사용되는 데이터의 개수를 리턴. : 필수 구현
    @Override
    public int getCount() {
        return filteredItemList.size() ;
    }

    // position에 위치한 데이터를 화면에 출력하는데 사용될 View를 리턴. : 필수 구현
    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        final int pos = position;
//        final int pos = filteredItemList.get(position).getNum();
        final Context context = parent.getContext();
        final String[] temp_str = new String[1];
        // "listview_item" Layout을 inflate하여 convertView 참조 획득.
        final ViewHolder holder;


        if (convertView == null) {
            holder = new ViewHolder();
            LayoutInflater inflater = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
            convertView = inflater.inflate(R.layout.activity_list_view_item, parent, false);
            holder.editText = (EditText)convertView.findViewById(R.id.editText);
            convertView.setTag(holder);
        }else{
            holder = (ViewHolder)convertView.getTag();
        }
        holder.ref = position;
//        Log.d("getView", String.valueOf(position));
        // 화면에 표시될 View(Layout이 inflate된)으로부터 위젯에 대한 참조 획득
        TextView descTextView = (TextView) convertView.findViewById(R.id.textView13) ;
        TextView valTextView  = (TextView) convertView.findViewById(R.id.textView14) ;

        final EditText valeditText  = (EditText) convertView.findViewById(R.id.editText) ;
        valeditText.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {
                temp_str[0] = s.toString();
//                Log.d("getView",temp_str[0] );
            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
            }

            @Override
            public void afterTextChanged(Editable s) {
                Log.d("getView",s.toString() );
                filteredItemList.get(holder.ref).setVal(s.toString());

//                valeditText.setText(s.toString());
//                valeditText.setText();
            }
        });
        EditText valeditText1  = (EditText) convertView.findViewById(R.id.editText1) ;
        valeditText1.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {

            }

            @Override
            public void afterTextChanged(Editable s) {
//                Log.d("EDIT TEXT POSITION1 : ", String.valueOf(pos));
                filteredItemList.get(holder.ref).setVal(s.toString());

            }
        });
        EditText valeditText2  = (EditText) convertView.findViewById(R.id.editText2) ;
        valeditText2.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {

            }

            @Override
            public void afterTextChanged(Editable s) {
//                Log.d("EDIT TEXT POSITION2 :  ", String.valueOf(pos));

                filteredItemList.get(holder.ref).setVal2(s.toString());
            }
        });
        final Button valbutton      = (Button) convertView.findViewById(R.id.listView_button) ;
        valbutton.setOnClickListener(new Button.OnClickListener() {
            public void onClick(View v) {
                if(valbutton.getText() =="ON") {
                    valbutton.setText("OFF");
                }
                else if(valbutton.getText()  == "OFF") {
                    valbutton.setText("ON");
                }
                else if (valbutton.getText()  == "MANUAL") {
                    valbutton.setText("AUTO");
                }
                else if (valbutton.getText()  == "AUTO") {
                    valbutton.setText("MANUAL");
                }
              //  valbutton.setText("OFF");
            }
        });
        // Data Set(listViewItemList)에서 position에 위치한 데이터 참조 획득
        ListViewItem listViewItem = listViewItemList.get(position);
        valTextView.setVisibility(View.VISIBLE);
        valeditText.setVisibility(View.VISIBLE);
        valbutton.setVisibility(View.VISIBLE);
        valeditText1.setVisibility(View.VISIBLE);
        valeditText2.setVisibility(View.VISIBLE);
        // 아이템 내 각 위젯에 데이터 반영
        descTextView.setText(listViewItem.getDesc());
        if(listViewItem.getMode() == "READ") {
            valTextView.setText(listViewItem.getVal());
            valeditText.setVisibility(View.INVISIBLE);
            valeditText1.setVisibility(View.INVISIBLE);
            valeditText2.setVisibility(View.INVISIBLE);
            valbutton.setVisibility(View.INVISIBLE);

        }
        else if(listViewItem.getMode() == "EDIT") {
            valTextView.setVisibility(View.INVISIBLE);
            valeditText.setText(listViewItem.getVal());
            valeditText1.setVisibility(View.INVISIBLE);
            valeditText2.setVisibility(View.INVISIBLE);
            valbutton.setVisibility(View.INVISIBLE);
        }
        else if(listViewItem.getMode() == "EDIT2") {
            valTextView.setVisibility(View.INVISIBLE);
            valeditText1.setVisibility(View.VISIBLE);
            valeditText2.setVisibility(View.VISIBLE);
            valeditText.setVisibility(View.INVISIBLE);
            valbutton.setVisibility(View.INVISIBLE);
            valeditText1.setText(listViewItem.getVal());
            valeditText2.setText(listViewItem.getVal2());
        }
        else if(listViewItem.getMode() == "BUTTON") {
            valTextView.setVisibility(View.INVISIBLE);
            valeditText.setVisibility(View.INVISIBLE);
            valeditText1.setVisibility(View.INVISIBLE);
            valeditText2.setVisibility(View.INVISIBLE);
            valbutton.setVisibility(View.VISIBLE);
            valbutton.setText(listViewItem.getVal());
        }else{
            valeditText1.setVisibility(View.INVISIBLE);
            valeditText2.setVisibility(View.INVISIBLE);
            valTextView.setVisibility(View.INVISIBLE);
            valeditText.setVisibility(View.INVISIBLE);
            valbutton.setVisibility(View.VISIBLE);
            //   valbutton.setText(listViewItem.getVal());
        }

//        descTextView.setBackgroundColor();
        return convertView;
    }
    // 지정한 위치(position)에 있는 데이터와 관계된 아이템(row)의 ID를 리턴. : 필수 구현
    @Override
    public long getItemId(int position) {
        return position ;
    }

    // 지정한 위치(position)에 있는 데이터 리턴 : 필수 구현
    @Override
    public Object getItem(int position) {
        return filteredItemList.get(position) ;
    }
    public void setItem(String desc,String val,String val2,String mode,int position) {
        ListViewItem item = new ListViewItem();
        item.setDesc(desc);
        item.setMode(mode);
        item.setVal(val);
        item.setVal2(val2);
        filteredItemList.set(position,item) ;
    }
    public void removeItem(int position) {
        filteredItemList.remove(position);
    }
    // 아이템 데이터 추가를 위한 함수. 개발자가 원하는대로 작성 가능.
    public void addItem(String desc,String val,String val2,String mode) {
        ListViewItem item = new ListViewItem();

        item.setDesc(desc);
        item.setMode(mode);
        item.setVal(val);
        item.setVal2(val2);

        filteredItemList.add(item);
    }
}
class ViewHolder {
    EditText editText;
    EditText editText1;
    EditText editText2;
    int ref;
}